;         Osborne Executive Compatible FASTLINK Version 1.0c
;      Copyright (C) 1983 by Kelly Smith and The Wizard of OsZ
;
; FASTLINK currently supports two way transfer of ASCII text files, between
; the CP/M disk and the remote computer system. The following control codes
; codes may be initiated from the console keyboard
;
; Revised October 18, 1983: Fixed reported "Break Bug" (Version 1.0b)
;
; Revised July 2, 1982: Added Transmit Break capability with Control-B Command.
;
; Revised May 17, 1983: Changed relocation scheme to allow 2k byte more for the
;                       disk text "save" buffer.  Added "user friendly" exit if
;                       Control-E (exit) key pressed.  Added bell attention for
;                       'File send complete', 'File name error or abort', 'File
;                       not found', and 'File send' aborted messages.  Both the
;                       Control-T (transmit) and Control-Y (Yank) command, will
;                       display incoming or outgoing ASCII data with proper tab
;                       expansion.  Added option (at CP/M command level)  for a 
;                       "trigger code" to  be used to send a new  line of ASCII
;                       (the default is an ASCII linefeed (0AH) character,  but
;                       'B' (bell,07H),   'X' (XON, 11H),   or 'U'  (no trigger
;                       check), may also be used to control the transmission of
;                       a ASCII file. Renamed to FASTLINK and Version 1.0, from
;                       PLINK Version 1.3.
;
; Revised August 9, 1983: Fixed "echo" bug at label 'link4'  (moved  'call wcc'
;                         to label 'link5' so that only input characters  go to
;                         the display screen, not also console characters. This
;                         revises code to version 1.0a.
;
;
;
; Control-E      Exit FASTLINK to CP/M "warm-boot".
;
; Control-T      Transmit ASCII file to remote computer system, asks for
;                drive (A, B, etc.) and filename.typ.
;
; Control-C      Aborts transmission of file to remote computer system.
;
; Control-Y      Switches between saving and ignoring
;                incoming ASCII data in RAM buffer,
;                for later transfer to disk.
;
; Control-W      Writes RAM buffer to disk, and asks for drive
;                and filename.typ.
;
; Control-H      Backspace when in command mode.
;
; Control-R      Repeat a command line entry when in command mode.
;
; Control-X      Delete a command line entry when in command mode.
;
; Control-U      Delete a command line entry when in command mode.
;
; Control-B	 Transmit a break level on Transmit Data Output
;
; (Note all other control codes are passed to serial port output, and
; may be interpreted by the remote computer system as various control
; functions.)
;
;
;
; The following end of line "trigger" equate is set to "lf" (linefeed)
; by default. An optional trigger character may be passed via the FCB1
; from the CP/M command line.
;
; i.e.,  FASTLINK B<cr> will set the end of line trigger to a "bell"
;
; The following options are allowed:
;
;	1. B = Bell  (07H)
;	2. X = XON   (11H)
;	3. U = Upload/Download with no trigger check at all
;
;
;bdos entry point and function codes
;
base	equ	0
bdos	equ	base+5
resdsk	equ	13	; reset disk system
offc	equ	15	; open file
cffc	equ	16	; close file
dffc	equ	19	; delete file
rrfc	equ	20	; read record
wrfc	equ	21	; write record
mffc	equ	22	; make file
;
;default fcb and field definitions
;
fcb	equ	base+5ch
fn	equ	1	; file name field (rel)
ft	equ	9	; file type field (rel)
ex	equ	12	; file extent field (rel)
nr	equ	32	; next record field (rel)
dbuf	equ	base+80h; default disk buffer address
;
;ascii control characters
;
bs	equ	08h	; backspace
cr	equ	0dh	; carriage return
lf	equ	0ah	; line feed
esc	equ	1bh	; escape
del	equ	7fh	; delete (rubout)
bell	equ	07h	; bell signal
tab	equ	09h	; horizontal tab
xon	equ	11h	; x-on character
null	equ	00h	; null char
;
trigger	equ	lf	;default value
;
;warning character for low memory
;
wrnsig	equ	bell
;
;serial port i/o port addresses
;
mdctlp	equ	0dh	; serial control port
mddatp	equ	0ch	; serial data port
mdrcvb	equ	01h	; serial port read data available mask
mdrcvr	equ	01h	; value when ready
mdsndb	equ	04h	; serial port transmitter buffer empty mask
mdsndr	equ	04h	; value when ready
break	equ	010h	; transmit break level (WR5)
;
	org	base+100h
;
	jmp	begin	; jump over copyright
;
	db	'Copyright (C) 1983 by Kelly Smith and The Wizard of OsZ'
;
begin:
;
	lxi	sp,stack+64 ; create local stack
	lhld	base+1	; point to CP/M jmp table
	lxi	d,3	; get ready to add 3
	dad	d	; point to con status jmp
	shld	citcal+1; modify call adrs
	dad	d	; point to con in jmp
	shld	rccal+1	; modify call adrs
	lda	fcb+1	; see if optional trigger char
	cpi	20h	; blank.. ?
	jz	skp	; ..blank so use default "lf"
	cpi	'B'	; bell (^G) wanted?
	jz	trgbel
	cpi	'X'	; xon (^Q) wanted?
	jz	trgxon
	cpi	'U'	; uploading, so no checking for trigger
	jz	trgupl
;
settrg:
;
	sta	overl3+1 ; store the user defined character, for trigger
	jmp	skp
;
trgbel:
;
	mvi	a,bell
	jmp	settrg
;
trgxon:
;
	mvi	a,xon
	jmp	settrg
;
trgupl:
;
	xra	a	; zero out jump
	sta	overl1+1; send linefeeds
	sta	overl2+1; change check for c/r to null
;
;reset and initialize the serial port
;
skp:
;
	mvi	a,018h	; channel reset to sio
	call	outctl
	mvi	a,004h
	call	outctl
	mvi	a,044h	; wr4: x16 clk divide, 1 stop bit, no parity
	call	outctl
	mvi	a,001h
	call	outctl
	mvi	a,000h	; wr1: no interrupts
	call	outctl
	mvi	a,003h
	call	outctl
	mvi	a,0c1h	; wr3: 8 bits, no auto enable, enable receive
	call	outctl
	mvi	a,005h
	call	outctl
	mvi	a,0eah	; w5: 8 bits, no auto enable, dtr and rts on
	call	outctl
;
	call	indata    ;clear serial port uart read buffers
	call	indata
;
cont:
;
	xra	a	; clear character buffers
	sta	inch
	sta	outch
	sta	flag	; clear text save flag
	lxi	h,tbuf	; set ptr to tbuf
	shld	ptr
	lxi	h,0	; size = 0
	shld	size
	lxi	h,linkms; print sign-on message
	call	wcs
;
;main loop
;
link3:
;
	call	citest	; jump if no data from console
	jz	link4
	call	rcc	; else read console data
	cpi	20h
	cc	pcc	; call pcc if control char
	jc	link4	; jump if pcc handled char
	ori	80h	; else set valid data bit
	sta	inch	; and store in input character buffer
;
link4:
;
	lda	outch	; jump if no data for console
	ora	a
	jp	link5
	xra	a	; then clear output character buffer
	sta	outch
;
link5:
;
	call	mitest	; jump if no data from serial port
	jnz	link6
	call	rmc2	; else read serial port data
	call	wcc	; send character to console
	call	save	; save character in text buffer if flag on
	ori	80h	; set data valid bit
	sta	outch	; store in output character buffer
;
link6:
;
	call	motest	; jump if serial port xmit buffer busy
	jnz	link7
	lda	inch	; jump if no data for serial port
	ora	a
	jp	link7
	ani	7fh	; discard valid data bit
	call	outdata	; output character to serial port
	xra	a	; ...then clear input character buffer
	sta	inch
;
link7:
;
	jmp	link3	; end of main loop
;
linkms:
;
	db	'Z'-40h,cr,lf
	db	tab,tab,'FASTLINK '
	db	esc,')'
	db	'Version 1.0, '
	db	esc,'('
	db	'(C) 1983, Wizard of OsZ (tm)'
	db	cr,lf
	db	esc,')'
	db	cr,lf,'Use the following Control Key entries as required:'
	db	cr,lf
	db	cr,lf,'['
	db	esc,'('
	db	'^T'
	db	esc,')'
	db	']ransmit, ['
	db	esc,'('
	db	'^Y'
	db	esc,')'
	db	']ank, ['
	db	esc,'('
	db	'^W'
	db	esc,')'
	db	']rite, ['
	db	esc,'('
	db	'^E'
	db	esc,')'
	db	']xit, ['
	db	esc,'('
	db	'^C'
	db	esc,')'
	db	']ancel'
	db	cr,lf
	db	cr,lf,'Ready for Control Key command entry '
	db	'('
	db	esc,'('
	db	'^T'
	db	esc,')'
	db	','
	db	esc,'('
	db	'^Y'
	db	esc,')'
	db	','
	db	esc,'('
	db	'^W'
	db	esc,')'
	db	','
	db	esc,'('
	db	'^E'
	db	esc,')'
	db	','
	db	esc,'('
	db	'^C'
	db	esc,')'
	db	'): '
	db	esc,'('
	db	cr,lf,lf,0
;
;pcc - process control character
;
pcc:
;
	cpi	'E'-40h	; jump out if ^E
	jnz	pcc1
	push	h
	lhld	size	; check for something in text buffer
	mov	a,l	; and give warning
	ora	h
	jz	xitchk	; before exit
	lxi	h,ays	; print 'do you want to save...
	call	wcs
	call	rcc	; get answer
	call	wcc	; echo it
	ani	5fh	; make upper case
	cpi	'Y'	; yes?
	cz	wtb	; write out buffer
;
xitchk:
;
	pop	h
	lxi	h,xityn	; print 'do you really want to exit to cp/m (y or n)? 
	call	wcs
	call	rcc	; get answer
	call	wcc	; echo it
	ani	5fh	; make upper case
	cpi	'Y'	; yes?
	jz	pccex	; if so, exit
	call	wccr	; crlf
	stc		; tell FASTLINK to ignore this character
	ret
;
pcc1:
;
	cpi	'T'-40h	; jump if not ^T
	jnz	pcc2
	call	stf	; transmit text file to serial port
	stc		; tell FASTLINK to ignore this character
	ret
;
pcc2:
;
	cpi	'Y'-40h	; jump if not ^Y
	jnz	pcc3
	lda	flag
	dcr	a	; was it zero?
	jnz	pcc2a	; yes
	sta	flag	; no, was 1, now 0
	lxi	h,pcmnix; print ignore incoming stuff
	jmp	pcc2b
;
pcc2a:
;
	mvi	a,1	; turn on text save flag
	sta	flag
	lxi	h,pccmr	; print 'saving incoming text in memory'
;
pcc2b:
;
	call	wcs
	stc		; tell FASTLINK to ignore this character
	ret
;
pcc3:
;
	cpi	'W'-40h	; jump if not ^W
	jnz	pcc4
	xra	a	; turn off text save flag
	sta	flag
	call	wtb	; write text buffer to disk
	stc		; tell FASTLINK to ignore this character
	ret
;
pcc4:
;
	cpi	'B'-40h	; jump if not ^B
	jnz	pcc5
	mvi	a,005h	; select wr5: 25-nov-83
	call	outctl
	mvi	a,0eah or break	; w5: break, 8 bits, no auto enable, dtr and rts on
	call	outctl
	lxi	h,sndbrk; display 'sending BREAK...' message
	call	wcs
	lxi	h,32	; 18-oct-83 "break bug" fix
;
pcc4a:
;
	xra	a	; make "dummy null" character
	call	wmc	; clock out 32 character time for "break"
	dcx	h
	mov	a,h
	ora	l
	jnz	pcc4a
	mvi	a,005h	; select wr5: 25-nov-83
	call	outctl
	mvi	a,0eah	; w5: 8 bits, no auto enable, dtr and rts on
	call	outctl
	stc		; tell FASTLINK to ignore this character
	ret
;
pcc5:
;
	stc		; let FASTLINK handle all other control codes
	cmc
	ret
;
pccex:
;
	lxi	h,xitms	; print exit message
	call	wcs
	jmp	base	; exit to warm boot
;
ays:
;
	db	cr,lf,'Do you want to save the text stored in'
	db	cr,lf,'the buffer before exit to CP/M (Y or N)? ',0
;
xityn:
;
	db	cr,lf,'Ready to exit to CP/M now (Y or N)? ',0

xitms:
;
	db	cr,lf,'+++ Exit to CP/M +++',cr,lf,0
;
pccmr:
;
	db	cr,lf,'Saving incoming text in memory',cr,lf,0
;
pcmnix:
;
	db	cr,lf,'Ignoring incoming text',cr,lf,0
;
sndbrk:
;
	db	cr,lf,'Sending BREAK to remote system',cr,lf,0
;
;stf - send text file (to serial port)
;
stf:
;
	call	gfn	; get name of disk file to send
	jc	stf6	; jump if file name error
	call	open	; try to open specified file
	cpi	255	; jump if file not found
	jz	stf7
;
stf1:
;
	call	read	; read next record into dbuf
	cpi	1	; jump if end-of-file
	jz	stf5
	lxi	h,dbuf 	; point to disk buffer
	mvi	c,128
;
stf2:
;
	mov	a,m	; fetch next character from dbuf
	inx	h
	cpi	'Z'-40h	; jump if end-of-file character
	jz	stf5
;
;user defined trigger gets 'patched here' if specified in command line
;
overl1:
;
	cpi	lf	; ignore line feeds
	call	wcc	; write character to console
	jz	stf4
	call	wmc	; write character to serial port
;
;user defined trigger gets 'patched here' if specified in command line
;
overl2:
;
	cpi	cr	; jump if not carriage return
	jnz	stf4
;
stf3:
;
	call	citest	; check console data ready
	jz	stf3a	; no data there
	call	rcc	; get console character
	cpi	'C'-40h	; control c aborts it
	jz	stf8
;
stf3a:
;
	call	mitest	; wait for next serial port character
	jz	stf3
	call	rmc2	; check serial port for trigger character
;
;user defined trigger gets 'patched here' if specified in command line
;
overl3:
;
	cpi	trigger
	jnz	stf3
;
stf4:
;
	dcr	c	; loop thru rest of dbuf
	jnz	stf2
	jmp	stf1	; go get next record from disk
;
stf5:
;
	lxi	h,stfsm	; print 'file send complete'
	call	wcs
	ret
;
stf6:
;
	lxi	h,stfs1	; print 'file name error'
	call	wcs
	ret
;
stf7:
;
	lxi	h,stfs2	; print 'file not found'
	call	wcs
	ret
;
stf8:
;
	lxi	h,stfsa	; print 'file send aborted'
	call	wcs
	ret
;
stfsm:
;
	db	cr,lf,lf,bell,'File send complete',cr,lf,0
stfs1:
;
	db	bell,'File name error or abort',cr,lf,0
stfs2:
;
	db	bell,'File not found',cr,lf,0
stfsa:
;
	db	cr,lf,bell,'File send aborted',cr,lf,0
;
;save - save character in text buffer if flag on
;
;     [A] - character to save
;
save:
;
	push	psw
	lda	flag
	ora	a
	jnz	save1
	pop	psw
	ret
;
save1:
;
	pop	psw
	cpi	del	; rubout (del) ?
	rz		; yes, ignore it
	cpi	20h	; test for control characters
	jnc	save2	; jump if not control character
	cpi	cr	; allow cr to be saved
	jz	save2
	cpi	lf	; allow lf to be saved
	jz	save2
	cpi	tab	; allow tab to be saved
	jz	save2
	ret		; ignore all other control characters
;
save2:
;
	push	h
	lhld	size	; size = size + 1
	inx	h
	shld	size
	lhld	ptr
	mov	m,a
	inx	h
	shld	ptr
	push	psw
	lda	base+7	; get system size
	sui	1	; so we dont crash CP/M
	cmp	h	; are we out of room?
	jz	saveab	; yes, abort
	sui	4	; leave some room (1k)
	cmp	h
	mvi	a,wrnsig; signal console running out of space
	cc	wcc
	pop	psw
	pop	h
	ret
;
;saveab - ran out of room, issue message and flow through to disk save routine
;
savend:
;
	db	bell,cr,lf,'Aborting - No room left in the text buffer!',0
;
saveab:
;
	lxi	sp,stack+64  ; reinitialize stack
	lxi	h,savend; print 'aborting - no room left'
	call	wcs
	lxi	h,begin	; set up return address
	push	h	; leave it on the stack
;
;wtb - write text buffer to disk
;
wtb:
;
	lhld	size	; jump if text buffer empty
	mov	a,l
	ora	h
	jz	wtb5
	mvi	c,resdsk; reset in case read-only
	call	bdos
	call	gfn	; get file name
	jc	wtb6	; jump if file name error
	call	delt	; delete old file, if any
	call	make	; make new file
	lhld	size	; [DE] = tbuf size
	xchg
	lxi	h,dbuf	; top of stack points to dbuf
	push	h
	lxi	h,tbuf	; [HL] points to tbuf
;
wtb1:
;
	mvi	c,128	; disk buffer size
;
wtb2:
;
	mov	a,m	; fetch next byte of tbuf
	inx	h
	xthl
	mov	m,a	; store in dbuf
	inx	h
	xthl
	dcx	d	; size = size - 1
	mov	a,d	; exit loop if size = 0
	ora	e
	jz	wtb3
	dcr	c	; loop until dbuf full
	jnz	wtb2
	call	write	; write full dbuf to disk
	xthl		; top of stack points to dbuf
	lxi	h,dbuf
	xthl
	jmp	wtb1	; loop until end of tbuf
;
wtb3:
;
	pop	h	; [HL] points to current place in dbuf
;
wtb4:
;
	mvi	m,'Z'-40h ; store eof code
	inx	h
	dcr	c	; loop thru rest of dbuf
	jnz	wtb4
	call	write	; write last sector to disk
	call	close	; clean up act and go home
	lxi	h,tbuf	; clear text buffer
	shld	ptr
	lxi	h,0
	shld	size
	lxi	h,wtbsm	; print 'buffer saved on disk'
	call	wcs
	ret
;
wtb5:
;
	lxi	h,wtbs1	; print 'text buffer empty'
	call	wcs
	ret
;
wtb6:
;
	lxi	h,wtbs2	; print 'file name error'
	call	wcs
	ret
;
wtbsm:
;
	db	cr,lf,'Buffer saved on disk',cr,lf
	db	'Memory save cancelled',cr,lf,0
;
wtbs1:
;
	db	'Text buffer empty',cr,lf,0
;
wtbs2:
;
	db	'File name error or abort',cr,lf,0
;
;wcs - write console string
;
;     [HL] - points to string (term by zero byte)
;
wcs:
;
	mov	a,m
	inx	h
	ora	a
	rz
	call	wcc
	jmp	wcs
;
;wccr - write console carriage return (and line feed)
;
wccr:
;
	mvi	a,cr
	call	wcc
	mvi	a,lf
;
;wcc - write console character
;
;     [A] - character to write
;
wcc:
;
	push	psw
	push	b
	push	d
	push	h
	mov	e,a	; character to [E] for bdos call
	mvi	c,2	; print character function
	call	bdos
	pop	h
	pop	d
	pop	b
	pop	psw
	ret
;
;
; rcs - read console string (with echo)
;  
;	[B] - number of characters read (<255) 
;	[HL] - points to last character stored (cr) 
;
rcs:
;
	lxi	h,ibuf 
	mvi	b,0
;
rcs1:
;
	call	rcc		; read next char from console
	cpi	bs		; if back space process as delete
	jz	rcs1a
	cpi	del		; jump if not del
	jnz	rcs2 
;
rcs1a:
;
	inr	b		; ignore del if ibuf already empty 
	dcr	b
	jz	rcs1 
	dcx	h		; else discard last char 
	mvi	a,bs		; delete with bs-sp-bs
	call	wcc
	mvi	a,' '
	call	wcc
	mvi	a,bs
	call	wcc
	dcr	b		; decrement count
	jmp	rcs1		; ..and loop 
;
rcs2:
;
	cpi	'X'-40h		; if ^X treat as delete entry
	jz	rcs2a
	cpi	'U'-40h		; jump if not ^U
	jnz	rcs3 
;
rcs2a:
;
	mvi	a,'#'		; line erase notate
	call	wcc
	call	wccr		; else abort current line
	jmp	rcs		; ..and start over 
;
rcs3:
;
	cpi	'R'-40h		; if not ^R to reprint line
	jnz	rcs3a
	push	h		; save parameters
	push	b
	mvi	a,'#'		; line erase notate
	call	wcc
	call	wccr		; new line at console
	mov	a,b		; if none input yet no looping
	ora	a
	jz	rcs3d		; exit ^R function if none to echo
	lxi	h,ibuf
;
rcs3l:
;
	mov	a,m		; character to print on screen
	call	wcc		; print it
	inx	h		; bump buffer print character
	dcr	b		; dec byte count
	jnz	rcs3l		; loop for more characters
;
rcs3d:
;
	pop	b		; restore parameters
	pop	h
	jmp	rcs1		; go loop for next character
;
rcs3a:
;
	call	wcc		; echo char to console 
	mov	m,a		; store char in ibuf 
	inr	b		; increment count
	cpi	cr		; jump if carriage return
	jz	rcs4
	inx	h		; else advance pointer 
	jmp	rcs1		; ..and loop 
;
rcs4:
;
	mvi	a,lf		; issue line feed and return 
	call	wcc
	ret 
;
;rcc - read console character
;
;     [A] - character read
;
rcc:
;
	push	b
	push	d
	push	h
;
rccal:
;
	call	$-$	; modified by init
	pop	h
	pop	d
	pop	b
	ret
;
;wmc - write serial port character
;
;     [A] - character to write
;
;
wmc:
;
	push	psw
;
wmcl:
;
	call	inctl
	ani	mdsndb
	cpi	mdsndr	;ready
	jnz	wmcl
	pop	psw
	ani	7fh	; strip parity bit
	call	outdata
	ret
;
;rmc - read serial port character
;
;     [A] - character read
;
rmc:
;
	call	inctl
	ani	mdrcvb
	cpi	mdrcvr
	jnz	rmc
;
rmc2:
;
	call	indata
	ani	7fh
	ret
;
;
;gfn - get file name
;
gfn:
;
	lxi	h,gfnsd	; print 'which drive?'
	call	wcs
	call	rcc	; get answer from console
	call	wcc	; echo it to console
	ani	5fh	; make upper case
	cpi	'C'-40h	; ^C means abort
	jz	gfn6
	sui	'A'-1
	jc	gfn	; require alphabetic
	jz	gfn
	cpi	17	; allow 16 drives (as in CP/M 2.x)
	jnc	gfn
	sta	fcb
;
gfnb:
;
	lxi	h,gfns1	; print 'filename? '
	call	wcs
	call	rcs	; read response into ibuf
	lxi	h,fcb+fn; blank fill fn and ft fields
	mvi	c,11
;
gfn1:
;
	mvi	m,' '
	inx	h
	dcr	c
	jnz	gfn1
	lxi	h,ibuf	; point to input buffer
	lxi	d,fcb+fn; scan off fn field
	mvi	c,9
;
gfn2:
;
	mov	a,m	; fetch next character from ibuf
	inx	h
	cpi	61h	; if lc, convert to uc
	jc	gfn2a
	sui	20h
;
gfn2a:
;
	cpi	cr	; jump if end of line
	jz	gfn5
	cpi	'.'	; jump if end of name
	jz	gfn3
	stax	d	; else store character in fn field
	inx	d
	dcr	c	; loop if 8 or less chars so far
	jnz	gfn2
	jmp	gfn6	; else take error exit
;
gfn3:
;
	lxi	d,fcb+ft; scan off ft field
	mvi	c,4
;
gfn4:
;
	mov	a,m	; fetch next character from ibuf
	inx	h
	cpi	61h	; if lc, convert to uc
	jc	gfn4a
	sui	20h
;
gfn4a:
;
	cpi	cr	; jump if end of line
	jz	gfn5
	stax	d	; else store character in ft field
	inx	d
	dcr	c	; loop if 3 or less chars so far
	jnz	gfn4
	jmp	gfn6	; else take error exit
;
gfn5:
;
	xra	a
	sta	fcb+ex	; set extent number to zero
	sta	fcb+nr	; set record number to zero
	stc		; clear error flag and return
	cmc
	ret
;
gfn6:
;
	stc		; set error flag and return
	ret
;
gfnsd:
;
	db	cr,lf,'Which drive? ',0
;
gfns1:
;
	db	cr,lf,'Filename? ',0
;
;open - open disk file
;
open:
;
	push	h
	push	d
	push	b
	lxi	d,fcb
	mvi	c,offc
	call	bdos
	pop	b
	pop	d
	pop	h
	ret
;
;read - read record from disk file
;
read:
;
	push	h
	push	d
	push	b
	lxi	d,fcb
	mvi	c,rrfc
	call	bdos
	pop	b
	pop	d
	pop	h
	ret
;
;close - close disk file
;
close:
;
	push	h
	push	d
	push	b
	lxi	d,fcb
	mvi	c,cffc
	call	bdos
	pop	b
	pop	d
	pop	h
	ret
;
;delt - delete disk file
;
delt:
;
	push	h
	push	d
	push	b
	lxi	d,fcb
	mvi	c,dffc
	call	bdos
	pop	b
	pop	d
	pop	h
	ret
;
;write - write record to disk
;
write:
;
	push	h
	push	d
	push	b
	lxi	d,fcb
	mvi	c,wrfc
	call	bdos
	pop	b
	pop	d
	pop	h
	ret
;
;make - make new disk file
;
make:
;
	push	h
	push	d
	push	b
	lxi	d,fcb
	mvi	c,mffc
	call	bdos
	pop	b
	pop	d
	pop	h
	ret
;
;citest - check console input status
;
citest:
;
	push	b
	push	d
	push	h
;
citcal:
;
	call	$-$	; modified by init
	ora	a	; set zero flag
	pop	h
	pop	d
	pop	b
	ret		; zero flag carries answer
;
;mitest - check serial port input status
;
mitest:
;
	call	inctl	; get serial port uart status
	ani	mdrcvb	; any data available?
	mvi	a,0
	jnz	mitst1
	cma
;
mitst1:
;
	ora	a
	ret		; zero flag carries answer
;
;motest - check serial port output status
;
motest:
;
	call	inctl	; get serial port uart status
	ani	mdsndb	; uart ready for character?
	mvi	a,0
	jnz	motst1	; zero flag carries answer
	cma
;
motst1:
;
	ora	a	; set zero flag if ready
	ret
;
;data area
;
inch:
;
	ds	1	; input character buffer 
;
outch:
;
	ds	1	; output character buffer
;
stack:
;
	ds	80	; local stack
;
ibuf:
;
	ds	256	; input buffer
;
;text buffer
;
flag:
;
	ds	1	; text save flag
;
ptr:
;
	ds	2	; text buffer pointer
;
size:
;
	ds	2	; text buffer size
;
; modem port i/o primitives
;
outdata:
;
	di
	out	mddatp
	ei
	ret
;
indata:
;
	di
	in	mddatp
	ei
	ret
;
outctl:
;
	di
	out	mdctlp
	ei
	ret
;
inctl:
;
	di
	in	mdctlp
	ei
	ret
;
tbuf:
;
;
;
	end
